/*
 * @(#)Analysis.java
 */
package galton.analysis;

import java.applet.*;
import java.awt.event.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.awt.Color;
import java.awt.BorderLayout;
import galton.common.*;
import galton.analysis.*;
import java.awt.Dimension;
import java.awt.Frame;


/**
 * An applet.
 */
public class Analysis extends Applet
		implements ActionListener, AdjustmentListener, Runnable{
    //**************************** controls **************************//
    Options opts;           //
    Results results;        // what the machine spits out
    ControlPanel control;   // a few buttons and scrollbars to work with machine
    Machine machine;        // a thread that does most of the work
    DisplayArea display;	// the place with big red bars, was Panel panel3;
    URL helpURL;            // the URL of the help page
    Thread appletThread;    // a thread whose target is applet
    Thread myThread;
    int DEBUG = 3;

    private galton.analysis.Language lang;

    /**
     * For being Runnable.
     * ?
     */
    public void start(){
      if(DEBUG>=2) System.out.println("An.start()");
        if(appletThread==null){
            appletThread=new Thread(this,"Analysis");
	    //    running=true;
            appletThread.start();
        if(DEBUG>=2) System.out.println(appletThread.getName()+" started");
	    //            new Thread( control ).start();
        }
    }

    /**
     * ?
     */
    public void stop(){
      if(DEBUG>=2) System.out.println("An.stop()");
	myThread=null;
    }

    /**
     * ?
     */
    public void run(){
	if(DEBUG>=2)System.out.println(""+machine.getSum()+": An.run()");
        myThread=Thread.currentThread();
	control.flipperSS.dispatchEvent(new ActionEvent(control.flipperSS,
							ActionEvent.ACTION_PERFORMED,
							lang.getName(Language.START)));
        while(myThread==appletThread){
	    display.repaint();
	    control.display();
        machine.getRepaintPermit(200);
      }
      machine.end();
	if(DEBUG>=3)System.out.println("An.run()~");
    }

    /**
     * For implementing ActionListener.
     * @see java.awt.event.ActionListener
     */
    public void actionPerformed(ActionEvent evt){
      String command=evt.getActionCommand();
	if(DEBUG>=2) System.out.println(""+machine.getSum()+": An.actionPerf:"+command);
	if(command.equals(lang.getName(Language.OK))){
	    display.setDist(opts.getDist());
	    display.repaint();
    	    return;
	}
        if(command.equals(lang.getName(Language.HELP))){
            int i=0;
            if(evt.getSource().equals(opts.helpButton))i=2;
	    //   if(evt.getSource().equals(results.getComponent(2)))i=3;
            if(evt.getSource().equals(control.getComponent(16)))i=1;
            try{
		  URL help=new URL(helpURL,"#s1"+i);
              if(DEBUG>=1) System.out.println("Trying to load \""+help+"\"...");
              getAppletContext().showDocument(help,lang.getName(Language.HELP));
            }catch(MalformedURLException e){
              System.out.println(""+e+" at Analysis");
            }
            return;
        }
	if(command.equals(lang.getName(Language.OPTION))){
	    //    opts.setVisible(true);
	    opts.update();
	    opts.show();
            return;
        }
        if(command.equals(lang.getName(Language.RESULT))){
            System.gc();
	    int size=opts.getDist().getSize();
            DistributionVector alldists=new DistributionVector(0);
            for(int i=0; i<size; i++)
		if((opts.getDist().distributionAt(i)!=null)&&opts.getDist().distributionAt(i).isVisible())
                    alldists.addDistribution(opts.getDist().distributionAt(i));
	    Distribution[] test=display.getTest();
	    for(int i=0; i<test.length; i++){
		if(DEBUG>=3) System.out.println(""+test[i].toString());
		if(test[i].isVisible())
		    alldists.addDistribution( test[i] );
	    }
	    results.display(machine,alldists);
	    //if(!results.isShowing())results.setVisible(true);
	    //results.toFront();
            return;
        }
        if(command.equals(lang.getName(Language.EBAR))){
            display.toggleEBars();
            display.repaint();
            return;
        }
        if(command.equals(lang.getName(Language.START))){
            boolean ready=true;
            if(!control.fieldn.parse(false))return;
            if(!control.fieldN.parse(false))return;
            //disable components
            control.fieldn.setEnabled(false);
            control.fieldN.setEnabled(false);
            control.pBar.setEnabled(false);
            control.serButton.setEnabled(false);
            control.sumButton.setEnabled(false);
            display.repaint();
            machine.setRunning(true);
            control.getComponent(14).setEnabled(false); //options
            control.getComponent(15).setEnabled(false); //results
            return;
        }
        if(command.equals(lang.getName(Language.STOP))){
            machine.setRunning(false);
            return;
        }
        if(evt.getSource()==control.fieldn.field){
            display.columnWidthChanged=true;
            machine.setn(control.fieldn.getValue());    //automatically stops machine
        }
        if(command.equals(control.sumButton.getLabel())){
            machine.setn(control.fieldn.getValue());    //automatically stops machine
	    display.repaint();
	    return;
        }
        if(command.equals(control.serButton.getLabel())){
            machine.clearCounter();
            return;
        }
        if(command.equals(control.fieldN.COMMAND)){
            machine.setN(control.fieldN.getValue());
            return;
        }
        if(command.equals(lang.getName(Language.TEST))){
            display.toggleTest();
            display.repaint();
            return;
        }
	}

    /**
     * For implementing AdjustmentListener.
     * @see java.awt.event.AdjustmentListener
     */
    public void adjustmentValueChanged(AdjustmentEvent evt){
      double val=(double)evt.getAdjustable().getValue()/100.0;
      machine.setp(val);
      if(display!=null){
        display.updateTest();
	  Distribution[] test=display.getTest();
    	  if(test[0].isVisible()||test[1].isVisible()||test[2].isVisible())
          display.repaint();
        }
    }

    //******************** constructors ******************************//
    /**
     * Initialises all of subcomponents, incl. lang, option, results, control.
     */

    /**
     * Nothing important done here.
     *
     * @override init() in java.applet.Applet
     */
    public void init(){
      lang = new galton.analysis.Language(this);
      machine=new Machine(false);	//not running

      setBackground(new Color(16096118));
      setLayout(new BorderLayout());

      try{
        helpURL=new URL(getDocumentBase(),lang.getName(Language.HELPURL));
      }catch(MalformedURLException e){
        System.err.println(""+e);
      }

      control=new ControlPanel(lang,machine,this,this);
      control.dispatch();

      machine.setn(control.fieldn.getValue());
	  machine.setN(control.fieldN.getValue());

      add(control,"West");
      machine.NMAX=lang.getValue(Language.NMAX);

      display=new DisplayArea(machine,lang);
      display.setBackground( new Color(16096118).brighter() ); //F59B76
      add(display,"Center");
      /* very important ^ -> otherwise in "Microsoft (R) VM for Java, 5.0 Release 5.0.0.3167" DA is not visible */


	results = new Results(lang.getName(Language.RESULT),lang);

    opts=new Options(lang.getName(Language.OPTION),this,lang);
      
    display.setDist(opts.getDist());
    this.addMouseListener(control); // ????!!!!
	if(DEBUG>=2) for(int i=0;i<getComponentCount();i++) System.out.println("* "+i+". "+getComponent(i));
//    display.setSize(new java.awt.Dimension(this.getSize().width-control.getSize().width,this.getSize().height));
//	System.out.println("An.init():DA.setSize("+new java.awt.Dimension(this.getSize().width-control.getSize().width,this.getSize().height)+")");
  };

    /**
     * Returns a description of all parameters.    
     * @return String[][] as [param. number,name=0/type=1/description=2]
     */
    public String[][] getParameterInfo(){
	    String[][] info = {
	        {"name"		, "type"		, "description"},
            {"INFO"     , "String array", "<x>,<k>,sx,sm,max"},
            {"CONTROL"  , "String array", "n,N,p,serie,sum,START,STOP,+,test,Distributions,Results"},
            {"VALUE"    , "String array", "10,1,500,500,1,10000000,50,20"},
            {"DCOLORS"  , "String array", "black,blue,cyan,darkGray,gray,green,lightGray,magenta,orange,pink,redy,white,yellow"},
            {"DNAMES"   , "String array", "binomial,normal,poisson"},
            {"DLABELS"  , "String array", "color,new,delete,ok,show?,distribution"},
            {"HELP"     , "String array", "Help,help.html"},
            {"MESSAGE"  , "String array", "p...,p...,serie[0..N]...,sum...,start/stop,N...,n...,<x>,<k>,sx,sm,maximum,error,test,distributions,results,help,version"}
	    };
	    return info;
    }
    /**
     * Returns general info about applet as a String.
     * @return Long String
     */
    public Dimension getPreferredSize(){
		return new Dimension(500,350);
	}

    public String getAppletInfo(){
        return "Analysis v."+lang.getVersionString()+"\nby Zbigniew Szmek\nzj186535@zodiac.mimuw.edu.pl";
    }
	public static void main(String args[]){
		java.awt.Frame f=new Frame("Analysis");
		f.add(new Analysis());
		f.setSize(f.getPreferredSize());
		f.pack();
		f.show();
	}

}