/*
 * @(#)NumberField.java
 */

package galton.common;

import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.*;

/**
 * ?
 *
 */
public class NumberField extends Panel
	implements FocusListener, ActionListener, MouseListener {  
    private static final int DEBUG=0;
    public TextField field;  
    private Label label;
    private int min, max;
    private int value;
    public String COMMAND;
    public NumberField (String text, int min, int max) {
      this.min = min;
      this.max = max;
      GridBagLayout gridbag = new GridBagLayout ();
      GridBagConstraints c = new GridBagConstraints ();
      setLayout (gridbag);
      c.fill = GridBagConstraints.BOTH;
      c.weightx = 1.0;
      c.gridwidth = GridBagConstraints.RELATIVE;
      label = new Label (COMMAND = text, Label.RIGHT);
      gridbag.setConstraints (label, c);
      add (label);
      c.gridwidth = GridBagConstraints.REMAINDER;
      c.weightx = 0.0;
      field = new TextField (" ", 10);
      gridbag.setConstraints (field, c);
      add (field);
      field.addFocusListener (this);
      field.addActionListener (this);
      field.addMouseListener (this);
      label.addMouseListener (this);
    } 
    public void addActionListener (ActionListener l) {
	field.addActionListener (l);
    } 

    public void setEnabled (boolean b) {
    	field.setEnabled (b);
    } 
    public void setValue (int newValue) {
    	if ((newValue < min) || (newValue > max))
              throw new IllegalArgumentException ("NumberField.setValue(illegal)");
	value = newValue;
	field.setText ("" + value);
    }
    public int getValue () {
	return value;
    }
   
    public boolean parse (boolean forceChange) {	//returns 1=success 0=failure
	int newValue;
    
      String str = field.getText ().trim ();
    
      if (str == null)
      return false;
    
      if (str.startsWith ("+"))
      str = str.substring (1);
    
      try {
      
	newValue = (new Integer (str)).intValue ();
      
    }
    catch (NumberFormatException e) {
      
	getToolkit ().beep ();
      
	field.requestFocus ();
      
	return false;
      
    }
    
      if ((newValue < min) || (newValue > max)) {
      
	getToolkit ().beep ();
      
	field.requestFocus ();
      
	return false;
      
    }
    
      field.setText ("" + newValue);
    
      if (forceChange || (value != newValue)) {
      
	value = newValue;
      
	field.dispatchEvent (new ActionEvent (this, ActionEvent.ACTION_PERFORMED, COMMAND));
      
    }
    
      return true;
    
  }
  
  //***************** focus events ***********************//
    public void focusGained (FocusEvent evt) {
    
    field.selectAll ();
    
//            getToolkit().beep();
  } 
    public void focusLost (FocusEvent evt) {
    
    parse (false);
    
  } 
  //***************** action events **********************//
    public void actionPerformed (ActionEvent evt) {    
        if(DEBUG>=2) System.out.println("NumberField.aP:"+evt);
	if (field.equals (evt.getSource ())) {
	    parse (false);
	    transferFocus ();
	}
    }   
  //**************** mouse events ***********************//
    public void mouseExited (MouseEvent e) {
    
    dispatchEvent (new MouseEvent (this, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ()));
    
  } 
    public void mouseEntered (MouseEvent e) {
    
    dispatchEvent (new MouseEvent (this, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ()));
    
  } 
    public void mousePressed (MouseEvent e) {
    
    dispatchEvent (new MouseEvent (this, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ()));
    
  } 
    public void mouseReleased (MouseEvent e) {
    
    dispatchEvent (new MouseEvent (this, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ()));
    
  } 
    public void mouseClicked (MouseEvent e) {
    
    dispatchEvent (new MouseEvent (this, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ()));
    
  } 
} 
