/*
 *@(#)Table.java
 */

package galton.table;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import galton.table.*;
import galton.common.ExtendedBar;

/**
 *  An applet displaying balls falling in a simulation of Galton's board.
 *
 */

public class Table extends Applet{

    public void init(){
	  lang = new Language(this);		


        //*********** make and show all the elements **//
	  setBackground(lang.getColor(Language.BACKGROUND_COLOR));
	  GridBagLayout gridbag=new GridBagLayout();
        GridBagConstraints c=new GridBagConstraints();
        setLayout(gridbag);
       if(DEBUG>=2)System.out.println("T.init():parsed and added layout");
       Label label;

       c.weighty=0.0;
	   c.ipadx=1;c.ipady=2;
	   c.insets=new Insets(2,2,2,2);
	   c.fill=GridBagConstraints.BOTH;

    	   c.gridheight=15; //3+
         c.weighty=1.0;
//         c.gridwidth=GridBagConstraints.RELATIVE;
         c.weightx=1.0;
        panel=new TableHead(lang,lang.getValue(Language.NEXP)==-1);
        try{
          panel.fallSound=getAudioClip(getCodeBase(),"../../fall.au");
          panel.leftSound=getAudioClip(getCodeBase(),"../../left.au");
          panel.rightSound=getAudioClip(getCodeBase(),"../../right.au");
        }catch(Exception e){
          System.err.println(""+e);
        }
        this.addMouseListener(panel);
       
        gridbag.setConstraints(panel,c);
        add(panel);
        if(DEBUG>=2)System.out.println("T.init():initialized TableHead");
        c.weighty=0.0;
        c.weightx=0.0;
        if(lang.isVisible(Language.n)){    //n bar
		     c.gridheight=6;
            bar1=new ExtendedBar(Scrollbar.VERTICAL,lang.getRange(lang.nEXP),
								10,TableHead.nBAR,lang.getName(Language.n)," = ");
            bar1.addAdjustmentListener(panel);
            bar1.nf.setGroupingUsed(false);
            bar1.setBackground(Color.blue);
            bar1.label.setForeground(Color.blue);
            bar1.label.setAlignment(Label.LEFT);
            gridbag.setConstraints(bar1,c);
            add(bar1);
    	}
        if(lang.isVisible(Language.N)){    //N bar
	    	c.gridheight=6;
            bar2=new ExtendedBar(Scrollbar.VERTICAL,lang.getRange(lang.NEXP),
								100,TableHead.NBAR,lang.getName(Language.N)," = ");

            bar2.addAdjustmentListener(panel);
            bar2.setBackground(Color.cyan);
            bar2.label.setForeground(Color.cyan);
            bar2.label.setAlignment(Label.LEFT);
            bar2.nf.setGroupingUsed(false);
            gridbag.setConstraints(bar2,c);
            add(bar2);
    	}

        Button button;
         c.gridheight=1;
         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.start)){
            button=new Button(lang.getName(Language.start));
            button.addActionListener(panel);
            gridbag.setConstraints(button,c);
            add(button);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.n)){
            gridbag.setConstraints(bar1.label,c);
            add(bar1.label);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.stop)){        //*** STOP
            button=new Button(lang.getName(Language.stop));
            button.addActionListener(panel);
            gridbag.setConstraints(button,c);
            add(button);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.N)){         //*** N numberee
            gridbag.setConstraints(bar2.label,c);
            add(bar2.label);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.step)){          //*** step
            button=new Button(lang.getName(Language.step));
            button.addActionListener(panel);
            gridbag.setConstraints(button,c);
            add(button);
    	}else add(new Label(),c);
         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.info)){    //*** info
            gridbag.setConstraints(panel.info0,c);
            add(panel.info0);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.clear)){        //*** CLEAR
            button=new Button(lang.getName(Language.clear));
            button.addActionListener(panel);
            gridbag.setConstraints(button,c);
            add(button);
    	}else add(new Label(),c);
         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.info)){    //*** info
            gridbag.setConstraints(panel.info1,c);
            add(panel.info1);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.add)){    //*** NEW
            button=new Button(lang.getName(Language.add));
            button.addActionListener(panel);
            gridbag.setConstraints(button,c);
            add(button);
    	}else add(new Label(),c);
         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.info)){    //*** info
            gridbag.setConstraints(panel.info2,c);
            add(panel.info2);
    	}else add(new Label(),c);
         c.gridwidth=GridBagConstraints.RELATIVE;
        if(lang.isVisible(Language.p)){        //*** p
            bar3=new ExtendedBar(Scrollbar.HORIZONTAL,lang.getRange(Language.pEXP),
								10,TableHead.pBAR,lang.getName(Language.p)," = ","",100);
            bar3.addAdjustmentListener(panel);
            bar3.nf.setMinimumFractionDigits(2);
            bar3.nf.setMaximumFractionDigits(2);
            bar3.setBackground(Color.green);
            bar3.label.setForeground(Color.green);
            bar3.label.setAlignment(Label.RIGHT);
            gridbag.setConstraints(bar3.label,c);
            add(bar3.label);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.REMAINDER;
        if(lang.isVisible(Language.info)){    //*** info
            gridbag.setConstraints(panel.info3,c);
            add(panel.info3);
    	}else add(new Label(),c);

         c.gridwidth=GridBagConstraints.REMAINDER;
//         c.gridwidth=4;
//         c.weightx=1.0;
        if(lang.isVisible(Language.p)){    ///*** p numberee
            gridbag.setConstraints(bar3,c);
            add(bar3);
    	}
      if(lang.isVisible(Language.speed)){   //*** speed
          bar4=new ExtendedBar(Scrollbar.HORIZONTAL,lang.getRange(Language.sEXP),5,TableHead.sBAR,
								lang.getName(Language.speed)," : ");
            bar4.addAdjustmentListener(panel);
            bar4.setBackground(Color.red);
            bar4.label.setForeground(Color.red);
            bar4.label.setAlignment(Label.LEFT);
//            bar4.label.setFont( new Font("Helvetica",Font.PLAIN,10) );
//             c.gridwidth=GridBagConstraints.RELATIVE;
             c.gridwidth=3;
            gridbag.setConstraints(bar4,c);
            add(bar4);
             c.gridwidth=GridBagConstraints.REMAINDER;
             c.gridheight=2;
//             c.gridwidth=1;
            gridbag.setConstraints(bar4.label,c);
            add(bar4.label);
    	}
        if(lang.isVisible(Language.xExplVisible)){ 
             c.gridheight=1;
            XExplanator xExpl=new XExplanator(lang);
            gridbag.setConstraints(xExpl,c);
            add(xExpl);
        }
        if(lang.isVisible(Language.maxVisible)){    //*** max
            gridbag.setConstraints(panel.infomax,c);
            add(panel.infomax);
    	}else add(new Label(),c);


        if(lang.isVisible(Language.maxVisible)){
            BallSizerPanel p = new BallSizerPanel(panel.Ball);
            p.addMouseListener(panel);
            add(p,c);
        }
        
        if(!lang.isVisible(Language.start)) panel.start();
    }

    protected class BallSizerPanel extends Panel{
        BallSizer b;
		     public BallSizerPanel(BallSizer b){
                     super(new GridBagLayout());
                     this.b=b;
                     GridBagConstraints c1=new GridBagConstraints();
                     if(DEBUG>=2)System.out.println("T.BallSizer-Panel. added layout");
                      c1.weighty=0.0;
	                c1.ipadx=1;c1.ipady=2;
	                c1.insets=new Insets(2,2,2,2);
	                c1.fill=GridBagConstraints.BOTH;
                      c1.weighty=1.0;
                      c1.weightx=1.0;
                      c1.gridwidth=GridBagConstraints.RELATIVE;             
                     add(b.im,c1);
                      c1.weightx=0.0;
                     c1.gridwidth=GridBagConstraints.REMAINDER;
                     add(b.tx,c1);
                 }
         public void addMouseListener(MouseListener l){
             super.addMouseListener(l);
             b.tx.addMouseListener(l);
             b.im.addMouseListener(l);
         }
    }


    //************************** variables **************************//
    private Language lang;
    public	Label	info0,info1,info2,info3;
    public ExtendedBar      bar1,bar2,bar3,bar4;
    public  Color   bgColor =Color.yellow;
    public  Color   ballColor=Color.red;
    public  Color   pinColor=Color.green;
    private int DEBUG = 2;

    private TableHead panel; /* is declared here only because of the inner class requierments */
}
