/*
 * @(#)DistributionVector.java
 */

package galton.analysis;

import java.util.Vector;
import java.util.Enumeration;
import galton.analysis.Distribution;

/**
 * A Vector containing Distributions.
 * @see galton.analysis.Distribution
 */
public class DistributionVector{
    private int size=0;
    private int distNumber=0;
    private Distribution data[];

    private static final int DEBUG = 0;

    public DistributionVector(int size){
		data=new Distribution[size];
		this.size=size;
    }
    public DistributionVector(){
		this(1);
    }
    public void fill(){
	for(int i=0;i<size;i++)
	    addDistribution(new Distribution(null));
    }
    public boolean generate(Machine machine){
	if(size<=3){
	    for(int i=0;i<size;i++)
		if(data[i]!=null)data[i].generate(i,machine);
	    return false; //OK
	}else return true; //problems
    }    
    public Distribution distributionAt(int index){
	return data[index];
    }
    public int nextNumber(){
        return ++distNumber;
    }
    public void addDistribution(Distribution dist){
		int index=0;
		while((index<size) && (data[index]!=null))index++;
		if(DEBUG>=2) System.out.println("index:"+index+" size:"+size+" data.length:"+data.length);
		if(index>=size){ 			// free place not found
			size++;
			data=newData(data);
		} //if
		data[index]=dist;
		if(DEBUG>=2) System.out.println("DV.add["+index+"/"+data.length+"]:"+data[index]);
    }
	public Distribution[] newData(Distribution[] data){
		Distribution[] data1=new Distribution[data.length+1];
	    for(int i=0;i<data.length;i++) data1[i]=data[i];
		if(DEBUG>=2) System.out.println("data:"+data.length+"data1:"+data1.length);
		return data1;
	}
    public void removeDistributionAt(int index){
	data[index]=null;
    }
    public void removeAll(){
	size=0;
	data=new Distribution[size];
    }
    public int getSize(){
	return size;
    }
    public boolean isEmpty(){
	for(int i=0;i<size;i++)
	    if(data[i]!=null)return false;
	return true;
    }
    public Enumeration elements(){
	Vector vector=new Vector();
	for(int i=0;i<size;i++)
	    if((data[i]!=null) && data[i].isVisible()) vector.addElement(data[i]);
	return vector.elements();
    }
}
