/*
 * @(#)Language.java	0.1 12/08/2000
 *
 */

package galton.analysis;

import java.applet.Applet;
import galton.common.Parse;
/** 
 * This is a standard implementation of Language.
 *
 */
public class Language extends Parse{
  private static final String	VERSION = "0.11  18.VIII.2000";

  public static final String MODIFIER = "!";
  public String nARG,NARG,STOPARG;

  private static final int CONTROL=0;
  public static final int nSTRING=CONTROL+0;
  public static final int NSTRING=CONTROL+1;
  public static final int pSTRING=CONTROL+2;
  public static final int kSTRING=CONTROL+3;
  public static final int xSTRING=CONTROL+4;
  public static final int SERIE  =CONTROL+5;
  public static final int SUM    =CONTROL+6;
  public static final int START  =CONTROL+7;
  public static final int STOP   =CONTROL+8;
  public static final int EBAR   =CONTROL+9;
  public static final int TEST   =CONTROL+10;
  public static final int OPTION =CONTROL+11;
  public static final int RESULT =CONTROL+12;
  public static final int HELP   =CONTROL+13;
 
  public static final int INFO  =14; 
  public static final int INFO1  =INFO+0;
  public static final int INFO2  =INFO+1;
  public static final int INFO3  =INFO+2;
  public static final int INFO4  =INFO+3;
  public static final int INFO5  =INFO+4;

  public static final int DNAMES      = 19; 
  public static final int BINOMIAL     = DNAMES+0;
  public static final int NORMAL       = DNAMES+1;  
  public static final int POISSON      = DNAMES+2;
  public static final int BERNOULLIE   = BINOMIAL;
  public static final int GAUSS        = NORMAL;
  
  private static final int DLABELS     = 22; 
  public static final int COLOR        = DLABELS+0;
  public static final int NEW          = DLABELS+1;
  public static final int DELETE       = DLABELS+2;
  public static final int OK           = DLABELS+3;
  public static final int SHOW         = DLABELS+4;
  public static final int VISIBLE      = SHOW;
  public static final int DISTRIBUTION = DLABELS+5;
  public static final int DELETEALL    = DLABELS+6;
  public static final int DELALL    = DELETEALL;

  public static final int HELPURL  = DLABELS+7;
  public static final int TOOPEN	= DLABELS+8;
  private static final int END = TOOPEN+1;

  public static final int nMIN=1,nMAX=2,nEXP=0,
                          NMIN=4,NMAX=5,NEXP=3,
                          pEXP=6;
  public static final String DEFAULT_STATUS = " ";

  public String dChar,tChar;

  /**
   * Expected number of messages.
   */
  public static final int MESSAGES = 22; 

  public static final int black = 1,blue=2,cyan=3,darkGray=4,gray=5,green=6,
                          lightGray=7,magenta=8,orange=9,pink=10,red=11,white=12,yellow=13;
  private String[] colors = {"black","blue","cyan","dark gray","gray","green","light gray",
                             "magenta","orange","pink","red","white","yellow"};

  private String[] names = {"n","N","p","k","x","In serie","Total","Start","Stop","+","Test",
                           "Distributions","Results","Help",
                           "<x>", "sx", "sm", "<k>", "max",
                           "binomial","normal","poisson",
                           "color","new","delete","OK","show","distribution","delete all",
                           "help.html","open the quantitive analysis window"};
  private String[] messages = {"p - the probability of the ball 'bouncing' left",
                               "push/drag to change p ( big step 1/10  smaxll step 1/100 )",
                               "number of balls in this serie [0 to N]",
                               "number of balls 'in the rack'",
                               "press to start / stop",
                               "enter a new value of N", 
                               "enter a new value of n",
                               "<x>","<k> = <x>+n/2","sx","sm = sx/N^0.5",
                               "the highestnumber of balls in column",
                               "toggle error bars",
                               "toggle test distributions",
                               "click to change/add distributions",
                               "click to see results in text form",
                               "press for help",
							   "clear the number of balls in this serie",
							   "clear all balls in the table",
							   "error1:",
							   "error2:",
                               "'Analysis' v0.09"};
  private int[] values = {50,1,500,
                          1000,1,100000,
                          50};
  private static final int VALUES = 7;


  /**
   * A standard constructor.
   *
   * @param applet an applet to parse its parameters
   */
  public Language(Applet applet){
	System.out.println("Language.<init>");
    this.applet=applet;

    String[] ar = parseParam("control",INFO-CONTROL);
    if (ar!=null) 
      for( int i=CONTROL;i<INFO;i++) names[i]=ar[i-CONTROL];

    ar = parseParam("info",DNAMES-INFO);
    if (ar!=null) 
      for( int i=INFO;i<DNAMES;i++) names[i]=ar[i-INFO];

    ar = parseParam("dnames",DLABELS-DNAMES);
    if (ar!=null) 
      for( int i=DNAMES;i<DLABELS;i++) names[i]=ar[i-DNAMES];
    
    ar = parseParam("dlabels",END-DLABELS);
    if (ar!=null) 
      for( int i=DLABELS;i<END;i++) names[i]=ar[i-DLABELS];

    ar = parseParam("message",MESSAGES);
    if (ar!=null) 
      for( int i=0;i<MESSAGES;i++) { messages[i]=ar[i]; System.out.println("message["+i+"]="+messages[i]); }
   
    ar = parseParam("value",VALUES);
    if (ar!=null)
      for( int i=0;i<VALUES;i++)
        try{
          values[i]=Integer.parseInt(ar[i]);
        } catch(NumberFormatException e){
          System.err.println("Invalid number format in "+i+" param. in 'values'");
        };
		
	ar = parseParam("dcolors",colors.length);
	if (ar!=null)
		for( int i=0;i<colors.length;i++){ colors[i]=ar[i]; }
	
    nARG = nSTRING + MODIFIER;
    STOPARG = STOP + MODIFIER;
    NARG = NSTRING + MODIFIER;

    dChar = ""+ getName(DISTRIBUTION).toUpperCase().charAt(0);
    tChar = ""+ getName(TEST        ).toUpperCase().charAt(0);
    
    if(DEBUG>=2) for(int i=0;i<names.length;i++) System.out.print(names[i]+(i<names.length-1 ? ", ":"\n"));
  }


  public int getColorNumber(String str){
    int i=0;
    while((i<colors.length) && (colors[i]!=str))i++;
    if(i==colors.length) throw new IndexOutOfBoundsException(""+str);
      else return i;
  }
  public String getColorName(int num){ return colors[num]; }
	
	public String getName(int num){ return names[num]; }
	public String getMessage(int num){ 
		return 0<=num && num<messages.length ? messages[num] : "out of bounds"; 
	}
	public int getValue(int num){ return values[num]; }
	public static String getVersionString(){ return VERSION; }
}