package galton.common;

import java.applet.*;
import java.lang.reflect.*;
import java.net.*;
import java.awt.*;
import java.awt.event.*;

public class AppletWrapper extends Applet{
     Applet applet;
     Frame frame;

     public AppletWrapper(Class a) 
     throws NoSuchMethodException, InstantiationException, IllegalAccessException,InvocationTargetException, ClassCastException{
         frame=new Frame();

         /* this should work iff all system dependent methods like getParameter() are called after setting the stub,
            that is, not during construction but during initialization */

//         if(!new Applet().getClass().isAssignableFrom(a))
//             throw new ClassCastException("AWrapper.AWrapper:a is not an Applet ("+a+")");

         System.out.println("AppletWrapper.<init>: a="+a);
         Class[] params = new Class[0];
         System.out.println("AppletWrapper.<init>: params="+params);
         Constructor constr = a.getConstructor(params);
         System.out.println("AppletWrapper.<init>: constr="+constr);
         applet=(Applet)constr.newInstance(params);
         System.out.println("AppletWrapper.<init>: applet="+applet);
         AppletStub stub = new AppletStub1(this);
         System.out.println("AppletWrapper.<init>: stub="+stub);
         applet.setStub(stub);

         frame.add( applet);        
         frame.addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dispose();
			}
         } );
     }

     public void dispose(){
         System.out.println("FrameImproved.dispose()");
         frame.dispose();	
     }


     /**
      * Provides a class that this wrapper should wrap.
      * @see init()
      */
     public AppletWrapper()
     throws NoSuchMethodException, InstantiationException, IllegalAccessException,InvocationTargetException, ClassCastException{
         this( new galton.analysis.Analysis().getClass() );
     }

     public void init(){
         System.out.println("AppletWrapper.init()");
         applet.init();         
         frame.setSize(getPreferredSize());
         frame.pack(); frame.show();
     }

     public static void main(String args[]) throws Exception{
         AppletWrapper wrapper = new AppletWrapper(Class.forName(args[0]));
         wrapper.init();
     }

     public void resizeApplet(int width, int height){ applet.setSize(width,height); }

     /**
      * A wrapper for running applets without a web page.
      * Calling getParameter when run from an interpreter causes NullPointerException.
      */
     public String getParameter(String name){
         try{
             return super.getParameter(name);
         }catch(NullPointerException e){
             return null;
         }
     }
     public AppletContext getAppletContext(){
         try{
             return super.getAppletContext();
         }catch(NullPointerException e){
             return new AppletContextAdapter(){};
         }
     }
     



     /********************************************************************************************************/
     public class AppletStub1 implements AppletStub{
         AppletWrapper parent;
         AppletStub1(AppletWrapper parent){
              this.parent = parent;
         }

         public void appletResize(int width, int height){ parent.resizeApplet(width,height); }

         public AppletContext getAppletContext(){ return parent.getAppletContext(); }
         public URL getCodeBase(){ 
             try{ return parent.getCodeBase(); }catch(NullPointerException e){ return null; } }
         public URL getDocumentBase(){
             try{ return parent.getDocumentBase(); }catch(NullPointerException e){ return null; } }
         public String getParameter(String name){ return parent.getParameter(name); }
         public boolean isActive() { return parent.isActive(); }
     }
}