/*
 * @(#)ExtendedBar.java	0.1 11/08/2000
 *
 */

package galton.common;

import java.awt.Label;
import java.awt.Scrollbar;
import java.text.NumberFormat;
import java.awt.event.AdjustmentListener;
import java.awt.event.AdjustmentEvent;
import galton.common.BarRange;
/**
 * A scroller used to precisly adjust a value.
 *
 * @author Zbigniew Jedrzejewski-Szmek
 */
public class ExtendedBar extends Scrollbar implements AdjustmentListener{
    public NumberFormat 	nf;
    public String 			preceder;
    public String 			sign;
    public String 			follower;
    public int 				divisor;
    public Label 			label;
    public int              id;

	/**
     *@deprecated Use the constructor with BarRange
     */
    public ExtendedBar(int orientation,int value,int visible,int min,int max,int id,
    					String preceder,String sign,String follower,int divisor){
        super(orientation,value,visible,min,max+visible);
        setBlockIncrement(visible);
        nf = NumberFormat.getInstance();
        this.preceder	=preceder;
        this.sign       =sign;
        this.follower   =follower;
        this.divisor    =divisor;
        this.id         =id;
        label=new Label(preceder+sign+nf.format((double)value/(double)divisor)+follower);
        addAdjustmentListener(this);
    }
	/**
     *@deprecated Use the constructor with BarRange
     */
    public ExtendedBar(int orientation,int value,int visible,int min,int max,int id,
    					String preceder,String sign){
        this(orientation,value,visible,min,max,id,preceder,sign,"",1);
    }


    public ExtendedBar(int orientation,BarRange range,int visible,int id,String preceder,String sign){
        this(orientation,range,visible,id,preceder,sign,"",1);
    }

    public ExtendedBar(int orientation,BarRange range,int visible,int id,
    					String preceder,String sign,String follower,int divisor){
        super(orientation,range.getExp(),visible,range.getMin(),range.getMax()+visible);
        setBlockIncrement(visible);
        nf = NumberFormat.getInstance();
        this.preceder	=preceder;
        this.sign       =sign;
        this.follower   =follower;
        this.divisor    =divisor;
        this.id         =id;
        label=new Label(preceder+sign+nf.format(getRealValue())+follower);
        addAdjustmentListener(this);
    }

    public void adjustmentValueChanged(AdjustmentEvent e){
        label.setText(preceder+sign+nf.format(getRealValue())+follower);
    }
    public double getRealValue(){
        return (double)getValue()/(double)divisor;
    }
}

