package galton.common;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.Label;
import java.awt.Button;
import java.awt.Insets;

public class MessageBox extends Dialog{
	protected static final boolean MODAL = true;
	protected Label label;
	public MessageBox(Frame parent,String title,String buttonLabel,String message){
		super(parent, title,  MODAL);
		System.out.println("MessageBox.<init>");
		setLayout(new GridBagLayout());
		
		Button button = new java.awt.Button(buttonLabel);
		button.addActionListener( new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dispose();
			}
		});		

		label = new Label(message);

		GridBagConstraints c = new GridBagConstraints();

	 	 c.fill = GridBagConstraints.BOTH;
	 	 c.gridwidth = GridBagConstraints.REMAINDER;
	 	 c.insets = new Insets (0, 0, 0, 0); //responsible for button padding
		 c.weightx=1.0;
		 c.weighty=1.0;
		add(label,c); 
		 c.weighty=0.0;
		add(button,c);
		addCloser();
	}
	public void setMessage(String message){ label.setText(message); }	
	private void addCloser(){
		this.addWindowListener( new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				dispose();
			}
			public void windowOpened(WindowEvent e){
/*
				* close the window after a specified time *
				new Thread(
				new Runnable(){
					public void run(){
						*
						synchronized(new Object()){
							try{ wait(20 * 1000); }catch(InterruptedException exception){}
						}
						*
						try{ Thread.sleep(20 * 1000);}catch(InterruptedException exception){}
						dispose();
					}
				}).start();
*/
			}
		} );		
	}	
}