/*
 * @(#)NumberField.java
 */

package galton.common;

import java.awt.Panel;
import java.awt.TextField;
import java.awt.Label;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Component;
import java.awt.Container;
import java.awt.Frame;
import java.awt.event.*;
import galton.common.Parse;

/**
 * ?
 *
 */
public class NumberField extends Panel
implements FocusListener, ActionListener, MouseListener {  

	private static final int DEBUG=0;
	public TextField field;  
	protected Label label;
	protected int min, max;
	protected int value;
	public String COMMAND;
	protected Parse parse;
	
	public NumberField (String text, int min, int max,Parse parse) {
		this.min = min;
		this.max = max;
		this.parse = parse;
		
		GridBagLayout gridbag = new GridBagLayout ();
		GridBagConstraints c = new GridBagConstraints ();
		setLayout (gridbag);
		c.fill = GridBagConstraints.BOTH;
		c.weightx = 1.0;
		c.gridwidth = GridBagConstraints.RELATIVE;
		label = new Label (COMMAND = text, Label.RIGHT);
		gridbag.setConstraints (label, c);
		add (label);
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weightx = 0.0;
		field = new TextField (" ", 10);
		gridbag.setConstraints (field, c);
		add (field);
		field.addFocusListener (this);
		field.addActionListener (this);
		field.addMouseListener (this);
		label.addMouseListener (this);
    } 
	
    public void addActionListener (ActionListener l) { field.addActionListener (l); } 
    public void setEnabled (boolean b) { field.setEnabled (b); } 
	
    public int getValue () { return value; }
    public void setValue (int newValue) {
    	if ((newValue < min) || (newValue > max))
              throw new IllegalArgumentException ("NumberField.setValue(illegal)");
		value = newValue;
		field.setText ("" + value);
    }
	
	protected String lastString;
    public boolean parse (boolean forceChange) {	//returns success / failure
		System.out.println("NField.parse("+forceChange+") : lastString="+lastString);
		int newValue;
		
		String str = field.getText().trim ();
		if( str == null ) { field.setText(""+value); return false; }
		
		if(str.startsWith ("+")) str = str.substring (1);
		
		if( str==lastString) {System.out.println("NField.parse() : str==lastString"); return false; }
			else System.out.println("NField.parse() : "+str+"!="+lastString);
		
		lastString = str;

		try {
			newValue = (new Integer (str)).intValue ();
		}catch(NumberFormatException e){
			field.requestFocus();
			field.setText(""+value);
			errorDetected(e);
			return false;
		}
		
		if ((newValue < min) || (newValue > max)) {
			field.requestFocus ();
			field.setText(""+value);
			errorDetected(new Integer(newValue));
			return false;
		}
    
		//field.setText ("" + newValue);
      	if (forceChange || (value != newValue)) {
			value = newValue;
			valueChanged(value);
		}
      
		return true;
	}  
	
	protected void errorDetected(Object param){};
	
	/** Called when the value really changes. Should usually be overriden by subclasses. */
	protected void valueChanged(int value){
		field.dispatchEvent (new ActionEvent (this, ActionEvent.ACTION_PERFORMED, COMMAND));	
	}
	
	//***************** focus events ***********************//
    public void focusGained (FocusEvent evt) {	
//    	field.selectAll ();
//            getToolkit().beep();
	} 
    public void focusLost (FocusEvent evt) {
		if(! evt.isTemporary()) parse (false);
	} 
	
	//***************** action events **********************//
    public void actionPerformed (ActionEvent evt){
        if(DEBUG>=2) System.out.println("NumberField.aP:"+evt);
		if( parse(false) ) transferFocus ();
    }   
	
	//**************** mouse events ***********************//
	public MouseEvent changeMouseEventOwner(Component owner,MouseEvent e){
		return new MouseEvent (owner, e.getID (), e.getWhen (), e.getModifiers (), e.getX (), e.getY (), e.getClickCount (), e.isPopupTrigger ());
	}	
	public void mouseExited (MouseEvent e)   { dispatchEvent (changeMouseEventOwner(this,e)); } 
	public void mouseEntered (MouseEvent e)  { dispatchEvent (changeMouseEventOwner(this,e)); } 
	public void mousePressed (MouseEvent e)  { dispatchEvent (changeMouseEventOwner(this,e)); } 
	public void mouseReleased (MouseEvent e) { dispatchEvent (changeMouseEventOwner(this,e)); }
	public void mouseClicked (MouseEvent e)  { dispatchEvent (changeMouseEventOwner(this,e)); } 
} 
