/*
 * @(#)Parse.java	0.1 11/08/2000
 *
 */

package galton.common;

import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.Font;
import java.awt.Label;
/**
 * This is an interface for changing languages and parameters 
 * through the <code>&lt;param&gt;</code> tags inside the <code>&lt;applet&gt;</code> tag
 * and easy access to them.
 *
 * @author Zbigniew Jedrzejewski-Szmek
 * @version 0.1, 11/08/2000
 */
public abstract class Parse {
  protected Applet applet;
  protected static final int DEBUG=3;
  protected Label frameStatus;

  /**
   * Parses an applet parameter.
   *
   * @param name the name of the parameter
   * @param num the number of ',' seperated items in the parameter body
   * @return num an array of length num with the parsed parameter
   */

  protected void parseSequential(String name,String[] holder,int beg,int end){
    String[] ar = parseParam(name,end-beg);
    System.out.print(name+" : [");
    if (ar!=null) for( int i=beg;i<end;i++) {
      System.out.print(holder[i]+"="+ar[i-beg]+" ");
      holder[i]=ar[i-beg];    
    }
    System.out.println("]");
  }


  protected String[] parseParam(String name,int num){
    if(DEBUG>=1) System.out.println("Parse.parseParam( "+name+", "+num+")");
    String param = applet.getParameter(name);
    if( param==null ) return null;
    param = param.trim();
    if(param==null) return null;
    String[] result=new String[num];
    for(int i=0;i<num;i++){
      param = param+",";  //ensure that there always is a next ','
      int a = param.indexOf(',');
      result[i] = param.substring(0,a).trim();
      param = param.substring(a+1,param.length());
    }
    return result;
  }
 
  public AppletContext getAppletContext(){
    return applet.getAppletContext();
  }

  public void showFrameStatus(String status){
      if(frameStatus!=null) frameStatus.setText(status);
  }
  public void setFrameStatus(Label frameStatus){ this.frameStatus = frameStatus; }
  public Label getFrameStatus(){ return frameStatus; }

  public static String getTabulator(){ return "\t\t"; }

  public static final Font 
    font_normal = new Font("Helvetica", Font.PLAIN, 16),
    font_bigger = new Font(font_normal.getName(),Font.PLAIN, font_normal.getSize()+1),
    font_smaller = new Font(font_normal.getName(),Font.PLAIN, font_normal.getSize()-1),
    font_info   = new Font("MonoSpaced", Font.ITALIC, font_normal.getSize ()-2);


}