/*
 * @(#)ButtonFlipper
 *
 */

package galton.common;

import java.awt.event.*;
import java.awt.*;

/**
 * An cross of an editbox and a button.
 *
 * @author Zbigniew Jedrzejewski-Szmek
 */
public class TextFlipper extends Panel implements ActionListener,MouseListener{
    private CardLayout layout;
    private long lastEventTime;
    private int[] RANGE;
    /**
     * The value of the textField.
     */
    public int value;
    public String A,B;
    public Button a;
    public TextField b;

    public TextFlipper(String A,String B,int[] RANGE,ActionListener l1,ActionListener l2,MouseListener l3){
	    this.A=A;
	    this.B=B;
	    this.RANGE=RANGE;
	    layout=new CardLayout();
	    setLayout(layout);
	    value=RANGE[0];
	    this.a=new Button(A+"="+value);
	    this.b=new TextField(""+value);
        if(l1!=null)a.addActionListener(l1);
        if(l2!=null)a.addActionListener(l2);
        if(l3!=null){
            a.addMouseListener(l3);
            b.addMouseListener(l3);
        }
        a.addActionListener(this);
        a.addMouseListener(this);
        b.addActionListener(this);
	    add(a,"a");
	    add(b,"b");
    }

    protected synchronized boolean parse(){
        int _value=0;
	    String _text=b.getText().trim();
	    try{
	        if(_text.charAt(0)=='+')_text=_text.substring(1,_text.length());
	        _value=Integer.parseInt(_text);
	    }catch(StringIndexOutOfBoundsException e){
	        this.getToolkit().beep();
	        System.err.println("Invalid entry");
	        return false;
	    }catch(NumberFormatException e){
	        System.err.println("Invalid entry-not a number : "+e.getMessage());
	        this.getToolkit().beep();
	        return false;
	    }
	    if(_value>=RANGE[1] && _value<=RANGE[2]){	//the _value is acceptable
	        this.value=_value;
	        a.setLabel(A+"="+value);
	        first();
	        return true;
    	    }else{				// stuff to do when the number is out-of-range
	        System.out.println("Invalid entry- "+_value+" is not between "+RANGE[1]+" and "+RANGE[2]);
	        this.getToolkit().beep();
	        return false;
	    }
    }

    /**
     * To be ActionListener.
     */
    public void actionPerformed(ActionEvent evt){
        if( evt.getSource().equals(a) && (evt.getModifiers()==0)){
            a.dispatchEvent(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,A));
            return;
        }
	    if( evt.getSource().equals(b) ){
	        if(parse())
                a.dispatchEvent(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,B));
	        return;
	    }
    }
    /**
     * To be MouseListener.
     */
    public void mouseClicked	(MouseEvent evt){
        if( evt.getSource().equals(a) && evt.isAltDown() ){
		    last();
            b.requestFocus();
            b.selectAll();
        }
    }
    /**
     * To be MouseListener.
     */
    /**
     * To be MouseListener.
     */
    public void mouseEntered	(MouseEvent evt){
    }
    /**
     * To be MouseListener.
     */
    public void mouseExited		(MouseEvent evt){
    }
    /**
     * To be MouseListener.
     */
    public void mousePressed	(MouseEvent evt){
    }
    /**
     * To be MouseListener.
     */
    public void mouseReleased	(MouseEvent evt){
    }
    /**
     * To be MouseListener.
     */
    public int getValue(){
		return value;
    }

    /**
     * Changes to label.
     */
    public void first(){
		layout.first(this);
    }
    /**
     * Changes to editbox
     */
    public void last(){
		layout.last(this);
    }
}
