package galton.event;

import galton.event.*;
import java.lang.Number;

public class AdjustmentEvent extends Event{
    protected final int ivalue;
	protected final double dvalue;
	
	public AdjustmentEvent(int type,double value)	{ super(type); dvalue = value; ivalue=0; }
	public AdjustmentEvent(int type,int value)		{ super(type); dvalue = 0.0; ivalue=value; }
	public AdjustmentEvent(int type)				{ super(type); dvalue = 0.0; ivalue=0; }
	
	public double getDoubleValue(){ return dvalue; }
	public int getIntegerValue()  { return ivalue; }
	
	public Number getValue(){
        switch(type){
            case pADJUSTMENT: return new Double(dvalue);
            case NADJUSTMENT: return new Integer(ivalue);
            case nADJUSTMENT: return new Integer(ivalue);
			case CLEARCOUNTER: return new Integer(ivalue);
            default      : return null;
        }
	}

    public String toString(){ return ""+getTypeLabel()+"="+getValue()+" "+super.toString(); }
    public String getTypeLabel(){
        switch(type){
            case UNKNOWN : return "UNKNOWN";
            case pADJUSTMENT:  return "p";
            case NADJUSTMENT:  return "N";
            case nADJUSTMENT:  return "n";
            case CLEARCOUNTER: return "clearCounter";
            default      : return super.getTypeLabel();
        }
    }
}