/*
 * @(#)Language.java	0.1 12/08/2000
 *
 */

package galton.table;

import java.applet.Applet;
import galton.common.Parse;
import java.awt.Color;
import java.awt.Font;
import galton.common.BarRange;
/** 
 * This is a standard implementation of Parse.
 *
 */
public class Language extends Parse{
  private static final String VERSION="0.1";

  private static final String[] names = {"start","stop","pause","step","clear","new","N","n","p","speed",
				    "<x>","sx","sm","<k>","max"};
  public static final int INFO_ID=names.length-5;

  private static final String[] messages = {"real value x=",
                               "measured value x'=",
                               "measurment",
                               "results",
                               "measurment",
                               "results",
                               "x","x'","real value","unreal value"};
  public static final int S1=messages.length-4,S2=S1+1,S3=S1+2,S4=S1+3;
  public static final int nMIN=1,nMAX=2,nEXP=0,
                          NMIN=4,NMAX=5,NEXP=3,
                          pEXP=6,pMIN=7,pMAX=8,
                          sEXP=9,sMIN=10,sMAX=11;
  private int[] values = {10,0,60,
                          250,0,1000,
                          50,0,100,
		              5,1,10};


    public					Font    MESG_FONT=      new Font("MonoSpaced",Font.BOLD,5);
    public	static final 	Font    MARKER_FONT=    new Font("Helvetica",Font.PLAIN,12);
    public	static final 	Font    BOLD_MARKER_FONT=new Font("Helvetica",Font.BOLD,12);


    private static Color[] COLORS={Color.red,Color.black,new Color(77,182,185),
 		Color.red, Color.pink, Color.blue, Color.yellow, Color.blue, Color.magenta, Color.blue, Color.red};

    public static final int X_COLOR     =0;
    public static final int EXPL_COLOR  =1;
    public static final int BORDER_COLOR=2;
	public static final int BALL_COLOR  =3;
    public static final int PIN_COLOR   =4;
    public static final int TABLE_COLOR =5;
    public static final int BACKGROUND_COLOR =6;
    public static final int COUNTER_COLOR    =7;
    public static final int XMARKER_COLOR    =8;
    public static final int KMARKER_COLOR    =9;
    public static final int ARROW_COLOR		 =10;
    public static final int MESSAGE_COLOR = 3;


    public static final int start = 0;
    public static final int stop  = 1;
    public static final int pause = 2;
    public static final int step  = 3;
    public static final int clear = 4;
    public static final int add   = 5;
    public static final int N     = 6;
    public static final int n     = 7;
    public static final int p     = 8;
    public static final int speed = 9;
    public static final int info1=10,info = 10;
    public static final int info2 = 11;
    public static final int info3 = 12;
    public static final int info4 = 13;
    public static final int info5 = 14;

	public static final int maxVisible     = info+1;
	public static final int mesgVisible    = info+2;
    public static final int counterVisible = info+3;
    public static final int arrowsVisible  = info+4;
	public static final int axisVisible    = info+5;
    public static final int xExplVisible   = info+6;

    /*
     *                        start,stop,pause,step,clear,add,   N,n,p,speed,         info,max   mesg,counter,arrows,axis, xexpl
     */
    private boolean SHOW[]  ={true,true, false,true,true,true,   true,true,true,true, true,true, true,true,true,true,      false};

  /**
   * A standard constructor.
   *
   * @param applet an applet whose parameters will be used
   */
  public Language(Applet applet){
    this.applet=applet;

    parseSequential("names",names,0,names.length);   
    parseSequential("message",messages,0,messages.length-4);
    if(applet.getParameter("xexplmesg")!=null){
      parseSequential("xexplmesg",messages,messages.length-4,messages.length);
      SHOW[xExplVisible] =  true;
    }
    String[] ar;
    ar = parseParam("SHOW",SHOW.length-1);
    if(ar!=null)
	  for( int i=0;i<(SHOW.length-1);i++)
		SHOW[i]= (ar[i]+" ").charAt(0)=='y';
    else System.out.println("parseParam('SHOW')= null");
		

    ar = parseParam("range",values.length);
    if (ar!=null)
      for( int i=0;i<values.length;i++)
        try{
          values[i]=Integer.parseInt(ar[i]);
        } catch(NumberFormatException e){
          System.err.println("Invalid number format in "+i+" param. in 'range'");
        };

    ar = parseParam("color",3*3);  
    if (ar!=null)
	  for( int i=0;i<9;i++)
        try{
		  COLORS[BACKGROUND_COLOR]=new Color(Integer.parseInt(ar[0]),Integer.parseInt(ar[1]),Integer.parseInt(ar[2]));
		  COLORS[BALL_COLOR]      =new Color(Integer.parseInt(ar[3]),Integer.parseInt(ar[4]),Integer.parseInt(ar[5]));
		  COLORS[TABLE_COLOR]     =new Color(Integer.parseInt(ar[6]),Integer.parseInt(ar[7]),Integer.parseInt(ar[8]));
        }catch(NumberFormatException e){
          System.err.println("Invalid number format in "+i+" param. in 'color'");
        }; 
    }

    public Color getColor(int id)              {return COLORS[id];}
    public String getXExplanatorString(int id) {return getMessage(messages.length-4+id);}
    public String getName(int id)              {return names[id];}
    public boolean isVisible(int id)           {return SHOW[id];}
    public static String getVersionString()    {return VERSION;}
    public String getMessage(int id)	       {return messages[id];}
    public int getValue(int id)				   {return values[id];}
	public BarRange getRange(int id){
      return new BarRange(getValue(id),getValue(id+1),getValue(id+2));
    }

}
