/*
 *@(#) TableHead.java
 */

package galton.table;

import galton.table.Language;
import galton.common.*;
import java.awt.event.*;
import java.awt.*;
import java.util.Random;
import java.text.NumberFormat;
import java.applet.AudioClip;

/**
 * ?
 */

public class TableHead extends Panel implements ActionListener,AdjustmentListener,MouseListener,Runnable{
    private static final int DEBUG = 0;
    private static final int MODIF = 1;
    private static final int VALUE = 0;

    public	static final 	int pBAR=0;
    public	static final 	int nBAR=1;
    public	static final 	int NBAR=2;
    public	static final 	int sBAR=3;

	private Language lang;

    public Numberee info0,info1,info2,info3,infomax;
    private Thread appletThread;
    public String action[];
    private int n,N;
    private double p,s;
    private Random random;
    private Point BallNew,BallOld;
    private int BallAdded;
    private Point OriginB,OriginC;
    private Rectangle ArrowBox;
    public BallSizer Ball;
    private boolean oneStepOnly;
    private boolean infiniteN;
    int c,l;
    int Table[][];
    private Point CPoint,Center,Origin;
    int oldWidth=0;
    int Mark;
    private Dimension col;
    private double xm,sx,sm,km;
    private int max;
    public  AudioClip leftSound,rightSound,fallSound;

    public TableHead(Language lang,boolean infiniteN){
	  this.lang = lang;
	  this.N = lang.getValue(Language.N);
        this.infiniteN=infiniteN;
        random=new Random(System.currentTimeMillis());
        BallAdded=-1;
        info0=new Numberee(0,lang.getName(lang.INFO_ID+0)," = ","");
        info1=new Numberee(0,lang.getName(lang.INFO_ID+1)," = ","");
        info2=new Numberee(9.99999,lang.getName(lang.INFO_ID+2)," = ","");
        info3=new Numberee(0,lang.getName(lang.INFO_ID+3)," = ","");
        infomax=new Numberee(0,lang.getName(lang.INFO_ID+4)," = ","");
        info0.setAlignment(Label.RIGHT);
        info1.setAlignment(Label.RIGHT);
        info2.setAlignment(Label.RIGHT);
        info3.setAlignment(Label.RIGHT);
        infomax.setAlignment(Label.CENTER);
        Ball = new BallSizer(1,lang.getColor(Language.BALL_COLOR));
        oneStepOnly=false;
        setCursor(new Cursor(Cursor.CROSSHAIR_CURSOR));
        this.addMouseListener(this);
        setn(lang.getValue(Language.nEXP));
        this.s = lang.getValue(Language.sEXP);
        this.p = lang.getValue(Language.pEXP)/100.0;
        this.N = lang.getValue(Language.NEXP);
	  clear();
        if(DEBUG>=2)System.out.println("TH.init():TableHead initialized");
    }


    public synchronized void setn(double n){
        if(DEBUG>=2)System.out.println("TH:setn( "+n+" )");
        this.n=(int)n;
        Table=new int[(int)n+1][2];
        for(int k=0;k<Table.length;k++) Table[k][MODIF]=1;
        c=l=0;
        max=0;
        Ball.setMultiplier(1);
        BallAdded=-1;
    }
    public void clear(){
        if(!infiniteN)stop();
        setn(n);
        BallNew=new Point(0,0);
        Ball.normalizeHeight();
        BallAdded=-1;
        repaint();
    }
    public void start(){
        if(DEBUG>=1)System.out.print("TH.start, ");
        if(appletThread==null){
            if(c==N) c=0;
            appletThread=new Thread(this,"TableHead");
	        appletThread.start();
        }
        if(DEBUG>=2)System.out.println("TH.appletThread="+appletThread);
    }
    public void stop(){
        if(DEBUG>=1)System.out.println("stop");
        appletThread=null;
    }
    private synchronized void addToTable(double b){
//        System.out.print("+");
        int k=(int)(b+ktox(n));   // same as xtok(b)
		if(Table[k][VALUE]==max)
            max++;
        Table[k][VALUE]++;
        Table[k][MODIF]++;
        BallAdded=k;
        l++;
        c++;
//        System.out.print(" c:"+c);
        if(c>=N && !infiniteN){
        	stop();
        }
	}
    public void run(){
	  if(DEBUG>=2)System.out.println("TH.run()");
        Thread myThread=Thread.currentThread();
        if(BallNew==null)BallNew=new Point(0,0);
        boolean firstStep=true;
        if(DEBUG>=2)System.out.println("TH.infiniteN="+infiniteN);
	  if(DEBUG>=2)System.out.println("TH.run: myThread==appletThread="+(myThread==appletThread)+" c="+c+" N="+N);
	  if(DEBUG>=2)System.out.println("TH.run: leftSound="+leftSound+" rightSound="+rightSound+" fallSound="+fallSound);
        while( myThread==appletThread && (infiniteN || (c<N && ( firstStep || !oneStepOnly ))) ){
//            if(DEBUG>=3)System.out.println("TH.run:Outside loop, oneStepOnly="+oneStepOnly+", firstStep="+firstStep);
            if(BallNew.x>=n ){
                BallNew=new Point(0,0);
            }
            while(BallNew.x<n && myThread==appletThread && ( firstStep || !oneStepOnly )){
//           	    if(DEBUG>=3)System.out.println("TH.run:Inside loop, oneStepOnly="+oneStepOnly+" firstStep="+firstStep+" s="+s);
                repaint();
                if(s<50)
                    try{
                        Thread.sleep((int)(1000/s));
                    }catch(InterruptedException e){
                    }
//                if(DEBUG>=3)System.out.println("TH.run():BallNew="+BallNew);
        	    if(random.nextDouble()<p){
                    BallNew.y++;
			  if(s<50 && leftSound!=null && rightSound!=null)rightSound.play();
                }else{
                    BallNew.y--;
			  if(s<50 && leftSound!=null && rightSound!=null)leftSound.play();
                }
                BallNew.x++;
                if(BallNew.x==n){
			  repaint();
                    try{
                        Thread.sleep((int)(1000/s));
                    }catch(InterruptedException e){
                    }
                    addToTable((double)BallNew.y/2.0);
                    repaint();
                    try{
                        Thread.sleep((int)(1000/s));
                    }catch(InterruptedException e){
                    }
                }
                firstStep=false;
//                if(DEBUG>=3)System.out.println("...!");
        	}
//            if(DEBUG>=3)System.out.println("...!");
            if(oneStepOnly)stop();
        }
        if(DEBUG>=3)System.out.println("TH.run:oneStep="+oneStepOnly);
        if(BallNew.x>=n ){
            BallNew=new Point(0,0);
        }
        repaint();
    }

    private void drawVertical(Graphics g,String str,int x,int y,int orientation){
        g.setFont(lang.MESG_FONT);
        Dimension size=new Dimension(g.getFontMetrics().charWidth((char)'w')*6/5,g.getFontMetrics().getAscent());
        for(int i=0;i<str.length();i++)
            if(orientation>0)
            	g.drawString(""+str.charAt(str.length()-1-i),x,y-size.height/2-orientation*size.height*i);
            else
                g.drawString(""+str.charAt(i),x,y+size.height/2-orientation*size.height*i);
    }
    private int max(int a,int b){return a>b?a:b;}
    private Font getVerticalFont(int w,int h){
	  int l1=max(lang.getMessage(2).length(),lang.getMessage(4).length());
        int l2=max(lang.getMessage(3).length(),lang.getMessage(5).length());

        Font font; FontMetrics m;
        int fontSize=0;
        do{
          fontSize++;
          font = new Font("Monospaced",Font.BOLD,fontSize);
	    m = getFontMetrics(font);  
        } while ((l2*m.getAscent()<h-(w-m.getMaxAdvance()*2)*Math.sqrt(2.0)/2.0) &&
		    (l1*m.getAscent()< (w-m.getMaxAdvance()*2)*Math.sqrt(2.0)/2.0));
        return new Font("Monospaced",Font.BOLD,fontSize-1);

    }

    private void updateCounter(Graphics g){
        if(lang.isVisible(Language.counterVisible) && CPoint!=null && Center!=null ){
        	g.setColor(lang.getColor(Language.COUNTER_COLOR));
            g.clearRect(CPoint.x-oldWidth-4,Center.y,oldWidth+4,CPoint.y-Center.y+1);
            FontMetrics metrics=g.getFontMetrics();
            String str=""+l;
            oldWidth=metrics.stringWidth(str);
            g.drawRect(CPoint.x-oldWidth-4,Center.y,oldWidth+4,CPoint.y-Center.y);
            g.drawString(str,CPoint.x-oldWidth-2,CPoint.y-2);
    	}
    }
    public void paint(Graphics g){
        int dl,dh,l1;
        FontMetrics metrics=getFontMetrics(lang.MARKER_FONT);
        dh=metrics.getHeight()*6/5;
        lang.MESG_FONT=getVerticalFont(getSize().width,getSize().height-4*dh);
        FontMetrics mesgMetrics=getFontMetrics(lang.MESG_FONT);
        dl=lang.isVisible(Language.mesgVisible)? mesgMetrics.charWidth((char)'w')*6/5:0;
        l1=getSize().width-2*dl;
        col=new Dimension((l1-1)/(n+1), (int)(Math.sqrt(2)/2*(double)((l1-1)/(n+1))) );
        Ball.setSize(col.width*2/3,col.width*2/3);
        Ball.setMultiplier(1);
        for(int k=0;k<=n;k++)Table[k][MODIF]++;
        Mark=(int)(n+1);

        Origin=new Point(dl, (n+1)*col.height+dh);
        OriginB=new Point(dl+col.width/2,getSize().height-3*dh-1);
        OriginC=new Point(dl+col.width/2,getSize().height-dh);
        ArrowBox=new Rectangle(dl,getSize().height-3*dh+2,(n+1)*col.width,dh);
        Center=new Point( Origin.x + (int)( ((double)n+1.0)/2.0*col.width),Origin.y-n*col.height);
        g.setColor(lang.getColor(Language.PIN_COLOR));
        int pinRadius=(Ball.width/4>3)?Ball.width/4:3;

        for(int i=0;i<n;i++)
            for(double j=-(double)i*0.5;j<=(double)i*0.5;j++)
	            g.fill3DRect(Center.x+(int)(j*(double)col.width)-pinRadius/2-1,Center.y+i*col.height,
                			  pinRadius,pinRadius,true);
        if(lang.isVisible(Language.mesgVisible)){
			g.setColor(lang.getColor(Language.KMARKER_COLOR));
            drawVertical(g,lang.getMessage(2),1,Origin.y,1);
            drawVertical(g,lang.getMessage(4),Origin.x+(n+1)*col.width+4,Origin.y,1);
    	}

        BallOld=new Point(0,0);
        drawBall(g);
        CPoint=new Point(2*Center.x-Origin.x,Center.y+metrics.getHeight());
        g.setColor(lang.getColor(Language.TABLE_COLOR));
        g.drawLine(Origin.x,getSize().height-3*dh,Origin.x+(n+1)*col.width,getSize().height-3*dh);
        g.drawLine(Origin.x,1+getSize().height-3*dh,Origin.x+(n+1)*col.width,1+getSize().height-3*dh);
        for(int i=0;i<=n+1;i++){
            g.drawLine(Origin.x+i*col.width,Origin.y,Origin.x+i*col.width,getSize().height-3*dh);
        }
        if(lang.isVisible(Language.mesgVisible)){
			g.setColor(lang.getColor(Language.XMARKER_COLOR));
            drawVertical(g,lang.getMessage(3),1,Origin.y,-1);
            drawVertical(g,lang.getMessage(5),Origin.x+(n+1)*col.width+4,Origin.y,-1);
        }
        drawAxisX(g);
//        if(DEBUG>=1)System.out.println("col : "+col);
//        if(DEBUG>=1)System.out.println("Origin : "+Origin);

        update(g);
	}
    private synchronized void drawColumn(Graphics g,int k,int val){
        g.setColor(lang.getColor(Language.BALL_COLOR));
        g.clearRect(OriginB.x+col.width*k-Ball.width/2,
                    Origin.y,
                    Ball.width,OriginB.y-Origin.y+1);
        for(int i=0;i<val/Ball.getMultiplier();i++)
            g.fillOval(	OriginB.x+col.width*k-Ball.width/2,
            			OriginB.y-Ball.height*(i+1),
                        Ball.width,Ball.height);
    }
    private void drawBottomArrow(Graphics g){
        g.setFont(lang.MARKER_FONT);
        g.setColor(lang.getColor(Language.ARROW_COLOR));
        String str=lang.getMessage(1)+NumberFormat.getInstance().format(ktox(BallAdded));
        int length=(int)(((double)BallAdded+0.5)*(double)ArrowBox.width/((double)n+1.0));
        g.clearRect(ArrowBox.x,ArrowBox.y,ArrowBox.width,ArrowBox.height);
        drawArrow(g,ArrowBox.x,ArrowBox.y+ArrowBox.height/2,length,ArrowBox.height/3);
        if(BallAdded>n/2){
	        g.clearRect(ArrowBox.x+6,ArrowBox.y,4+g.getFontMetrics().stringWidth(str),ArrowBox.height);
            g.drawString(str,ArrowBox.x+8,ArrowBox.y+ArrowBox.height-1);
        }else{
            g.drawString(str,ArrowBox.x+ArrowBox.width-g.getFontMetrics().stringWidth(str)-8,ArrowBox.y+ArrowBox.height/2+g.getFontMetrics().getAscent()/2);
        }
//            g.drawString(lang.getMessage(2),metrics.getMaxAdvance()+2,metrics.getAscent());
    }
    public void update(Graphics g){
        if(Mark!=(n+1)){
            g.clearRect(0,0,getSize().width,getSize().height);
            paint(g);
        }

        while( Ball.height*max > Ball.getMultiplier()*(OriginB.y-Origin.y-Ball.height)){
            if (Ball.height>6) Ball.decreaseHeight(); else Ball.setNextMultiplier();
            if(infiniteN) clear();
                    else  for(int k=0;k<=n;k++)Table[k][MODIF]++;	
        }

        for(int k=0;k<=n;k++)
            if(Table[k][MODIF]>0){
                drawColumn(g,k,Table[k][VALUE]);
                Table[k][MODIF]=0;
            }
        updateCounter(g);
        drawBall(g);
        if(lang.isVisible(Language.arrowsVisible) &&  BallAdded>=0)drawBottomArrow(g);
//        drawArrow(OriginB.x,OriginB.y+2+
        makeInfo();
        info0.setValue(xm);
        info1.setValue(sx);
        info2.setValue(sm);
        info3.setValue(km);
        infomax.setValue(max);
    }

    public synchronized void drawBall(Graphics g){
//        System.out.print("-");
	    Point BallCurrent=new Point(0,0);
        if (BallNew!=null) BallCurrent=new Point(BallNew);
        if (BallOld!=null) {
          g.setColor(lang.getColor(Language.BACKGROUND_COLOR));
          int i=BallOld.x;
          double j=BallOld.y/2.0;
          g.fillOval(	Center.x+(int)(j*(double)col.width)-col.width/3,
         			Center.y+i*col.height-col.width*2/3-1,
                        Ball.width,Ball.width); /* ball should be square */
        }
        if (BallCurrent!=null){
          g.setColor(lang.getColor(Language.BALL_COLOR));
//        if(fallSound!=null && i==n)fallSound.play();
          double i=BallCurrent.x;
          double j=BallCurrent.y/2.0;
          g.fillOval(	Center.x+(int)(j*(double)col.width)-col.width/3,
        			(int)(Center.y+i*col.height-col.width*2/3-1),
                        Ball.width,Ball.width); /* ball should be square */
        }
        BallOld=BallCurrent;
    }
    public synchronized void makeInfo(){
        double _EX=0;
        //first find _EX and xm
        for(int _k=0;_k<=n;_k++)
            _EX+=(double)Table[_k][VALUE]*ktox(_k);
        xm=_EX/l;   //was l,c
        km=xm+ktox(n);
        //and then other variables
        double _X2=0;
        for(int _k=0;_k<=n;_k++)
            _X2+=Math.pow(ktox(_k)-xm,2)*Table[_k][VALUE];
        sx=Math.sqrt( _X2/((double)l-1.0));
        sm=Math.sqrt( _X2/(double)l/((double)l-1.0));
    }
    public double ktox(double k){
	    return (double)k-(double)n/2.0;
    }

    private int getFirstMarker(int unit){
        int a=(int)(-ktox(0)-Math.floor(-ktox(0)/(double)unit)*(double)unit);
        return a<0?0:a;
    }

    private void drawAxisX(Graphics g){
		NumberFormat nf=NumberFormat.getInstance();
        g.setFont(lang.MARKER_FONT);
		FontMetrics metrics=g.getFontMetrics();
        int unit=1;
        while(	(double)(100/unit)!=100.0/(double)unit ||
        		metrics.stringWidth(nf.format(ktox(0)))*1.5 >= col.width*unit ) unit++;
//		g.clearRect(0,OriginB.y+3,Bounds.width,Bounds.height-Origin.y);
		int ypoint=OriginB.y+3+metrics.getMaxAscent()*6/5*2;

        if(lang.isVisible(Language.axisVisible)){
            g.setFont(lang.BOLD_MARKER_FONT);
			g.setColor(lang.getColor(Language.XMARKER_COLOR));
			g.drawString("x",0,ypoint);
			g.setColor(lang.getColor(Language.KMARKER_COLOR));
			g.drawString("k",0,ypoint+metrics.getAscent()+2);
            g.setFont(lang.MARKER_FONT);
            for(int k=getFirstMarker(unit);k<=n;k+=unit){
                int xcenter=OriginB.x+ k*col.width;
    //            g.drawLine(0,0,xcenter,ypoint);
			    g.setColor(lang.getColor(Language.XMARKER_COLOR));
			    g.drawString(nf.format(ktox(k)),
				    xcenter-metrics.stringWidth(nf.format(ktox(k)))/2, ypoint);
			    g.setColor(lang.getColor(Language.KMARKER_COLOR));
			    g.drawString(nf.format(k),
				    xcenter-metrics.stringWidth(nf.format(k))/2, ypoint+metrics.getAscent()+2);
		    }
        }
        if(lang.isVisible(Language.arrowsVisible)){
            metrics=g.getFontMetrics();
            drawArrow(g,0,metrics.getAscent()/2+2,Center.x,metrics.getAscent()/2+2);
            g.clearRect(metrics.getMaxAdvance(),0,
            			metrics.stringWidth(lang.getMessage(0))+2,metrics.getAscent());
            g.drawString(lang.getMessage(0),metrics.getMaxAdvance()+1,metrics.getAscent());
        }
    }
    private void drawArrow(Graphics g,int x,int y,int r,int arl){
        g.setColor(lang.getColor(Language.ARROW_COLOR));
        g.drawLine(x,y,x+r,y);
        g.drawLine(x,y+1,x+r,y+1);
        g.drawLine(x,y-1,x+r,y-1);
        if(3*arl<r){    // to rule out _~_>->|
            int[] xPoints={x+r,x+r-3*arl,x+r-3*arl,x+r,	x+r,x+r-3*arl-1,x+r-3*arl-1,x+r};
            int[] yPoints={y,y-arl,y+arl,y,				y-1,y-arl-1,y+arl+1,y+1};
							    //must be same length as xPoints
            g.drawPolygon(xPoints,yPoints,xPoints.length);
    	}
        g.drawLine(x+r,y-arl,x+r,y+arl);
	}




    public void mouseClicked(MouseEvent e){
             System.out.println("TH.mouseClicked");
       if(e.getComponent()==this){
            Mark=-1;
            repaint();
    	  }else{
		e.getComponent().invalidate();
//        	e.getComponent().doLayout();
        }
    }
    public void mouseEntered(MouseEvent e){}
    public void mouseExited(MouseEvent e){}
    public void mousePressed(MouseEvent e){}
    public void mouseReleased(MouseEvent e){}

    public void actionPerformed(ActionEvent action){
        if(DEBUG>=2)System.out.println("TH.actionPerformed("+action.getActionCommand()+")");
        if(action.getActionCommand()==lang.getName(Language.start)){
            oneStepOnly=false;
        	start();
        }
        if(action.getActionCommand()==lang.getName(Language.stop)) stop();
        if(action.getActionCommand()==lang.getName(Language.clear)) clear();
        if(action.getActionCommand()==lang.getName(Language.add)){
            BallNew.move(0,0);
            repaint();
        }
        if(action.getActionCommand()==lang.getName(Language.step)){
            if(!oneStepOnly){
                stop();
	            oneStepOnly=true;
            } else start();
        }
    }
    public void adjustmentValueChanged(AdjustmentEvent e){
        ExtendedBar src;
        if(e.getSource() instanceof ExtendedBar){
            src=(ExtendedBar)e.getSource();
            if( src.id==pBAR ){ p=src.getRealValue(); }
            if( src.id==nBAR ){ 
                setn(src.getRealValue());
                repaint();
            }
            if( src.id==NBAR ){ N=(int)src.getRealValue(); }
            if( src.id==sBAR ){ s=src.getRealValue(); }
        }
    }

}
