/*
 *@(#) XExplanator.java
 */

package galton.table;

import java.awt.Label;
import java.awt.Graphics;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import galton.table.Language;

/**
 * Displays an explenation of symbols used by class Table.
 * @see Table
 */
public class XExplanator extends Label{
    private Language lang;

    public XExplanator(Language lang){
      this.lang=lang;      
    }
    public void paint(Graphics g){
        Font font=getFont();
        FontMetrics metrics=getFontMetrics(font);

        int S1 = metrics.stringWidth(lang.getXExplanatorString(0));
        int S2 = metrics.stringWidth(lang.getXExplanatorString(1));
        int S3 = metrics.stringWidth(lang.getXExplanatorString(2));
        int S4 = metrics.stringWidth(lang.getXExplanatorString(3));
        int w1=2*( S1>S2 ? S1:S2 );
        int w2=    S3>S4 ? S3:S4;

        int h=metrics.getHeight();

        g.setColor(lang.getColor(lang.BORDER_COLOR));
        g.fill3DRect(0,0,getSize().width,getSize().height,true);

        g.setColor(Color.white);
        g.fill3DRect(5,5,w1,h,false);
        g.fill3DRect(10+w1,5,getSize().width-15-w1,h,false);
        g.fill3DRect(5,10+h,w1,h,false);
        g.fill3DRect(10+w1,10+h,getSize().width-15-w1,h,false);

        g.setColor(lang.getColor(lang.X_COLOR));
        g.setFont(new Font(font.getName(),Font.BOLD,font.getSize()));

        g.drawString(lang.getXExplanatorString(0),7,3+h);
        g.drawString(lang.getXExplanatorString(1),7,8+2*h);

        g.setColor(lang.getColor(lang.EXPL_COLOR));
        g.setFont(font);
        g.drawString(lang.getXExplanatorString(2),12+w1,3+h);
        g.drawString(lang.getXExplanatorString(3),12+w1,8+2*h);
    }
    public Dimension getPreferredSize(){
        FontMetrics metrics=getFontMetrics(getFont());
        int S1 = metrics.stringWidth(lang.getXExplanatorString(0));
        int S2 = metrics.stringWidth(lang.getXExplanatorString(1));
        int S3 = metrics.stringWidth(lang.getXExplanatorString(2));
        int S4 = metrics.stringWidth(lang.getXExplanatorString(3));
        int w1=2*( S1>S2 ? S1:S2 );
        int w2=    S3>S4 ? S3:S4;
        return new Dimension( 3*5+w1+w2,3*5+metrics.getHeight()*2);
    }
}
